Bullet = Class{}

function Bullet:init(x, y, width, height, speedX, speedY, lifeTime, type)
    self.entity = Entity(x, y, width, height, type)
    self.speedX = speedX
    self.speedY = speedY
    self.lifeTime = lifeTime
    self.startTime = os.time()
    self.texture = love.graphics.newImage('bullet.png')
end

function Bullet:update(dt) 
    self.entity:move(self.speedX, self.speedY, dt)
    self:loopPos()
end

function Bullet:draw()
    love.graphics.draw(self.texture, self.entity.x, self.entity.y, 0.75, 0.75)
end

function Bullet:loopPos()
    if self.entity.x >= VIRTUAL_WIDTH then
        self.entity:moveTo(0, self.entity.y)
    elseif self.entity.x <= 0 then 
        self.entity:moveTo(VIRTUAL_WIDTH, self.entity.y)
    end
    if self.entity.y >= VIRTUAL_HEIGHT then
        self.entity:moveTo(self.entity.x, 0)
    elseif self.entity.y <= 0 then 
        self.entity:moveTo(self.entity.x, VIRTUAL_HEIGHT)
    end
end