Rock = Class{}

function Rock:init(x, y, moveSpeedx, moveSpeedy, rotateSpeed, texturePath, size)
    if size == 'big' then
        self.width = 77
        self.height = 77
    elseif size == 'med' then
        self.width = 37
        self.height = 37
    else
        self.width = 17
        self.height = 17
    end
    self.entity = Entity(x, y, self.width, self.height, 'rock')
    self.angle = 0
    self.moveSpeedx = moveSpeedx
    self.moveSpeedy = moveSpeedy
    self.rotateSpeed = rotateSpeed
    self.texturePath = texturePath
    self.size = size
    self.texture = love.graphics.newImage(self.texturePath .. self.size .. math.random(1, 2) .. ".png")
    self.quad = love.graphics.newQuad(x, y, self.width, self.height, self.texture:getDimensions())
    self.sound = love.audio.newSource('Explosion.wav', 'static')
end

function Rock:update(dt)
    self.entity:move(self.moveSpeedx, self.moveSpeedy, dt)
    self.angle = self.angle + self.rotateSpeed * dt
    self:loopPos()
end

function Rock:draw()
    love.graphics.draw(self.texture, self.entity.x, self.entity.y, self.angle, 0.75, 0.75, self.entity.width / 2, 
        self.entity.height / 2)
end

function Rock:spawnRocks()
    if self.size == 'big' then
        table.insert(rocks, 1, Rock(self.entity.x - 10, self.entity.y, -self.moveSpeedx * 1.1, self.moveSpeedy * 1.1,
         -self.rotateSpeed * 1.25, self.texturePath, 'med'))
        table.insert(rocks, 1, Rock(self.entity.x + 10, self.entity.y, self.moveSpeedx * 1.1, -self.moveSpeedy * 1.1,
        self.rotateSpeed * 1.25, self.texturePath, 'med'))
    elseif self.size == 'med' then
        table.insert(rocks, 1, Rock(self.entity.x - 2, self.entity.y, -self.moveSpeedx * 1.1, self.moveSpeedy * 1.1,
         -self.rotateSpeed * 1.25, self.texturePath, 'small'))
        table.insert(rocks, 1, Rock(self.entity.x + 2, self.entity.y, self.moveSpeedx * 1.1, -self.moveSpeedy * 1.1,
         self.rotateSpeed * 1.25, self.texturePath, 'small'))
    end
end

function Rock:loopPos()
    if self.entity.x >= VIRTUAL_WIDTH then
        self.entity:moveTo(0, self.entity.y)
    elseif self.entity.x <= 0 then 
        self.entity:moveTo(VIRTUAL_WIDTH, self.entity.y)
    end
    if self.entity.y >= VIRTUAL_HEIGHT then
        self.entity:moveTo(self.entity.x, 0)
    elseif self.entity.y <= 0 then 
        self.entity:moveTo(self.entity.x, VIRTUAL_HEIGHT)
    end
end