Xplosion = Class{}


function Xplosion:init(x, y, size, texture)
    self.entity = Entity(x, y, 16, 16)
    self.size = size
    self.texture = love.graphics.newImage(texture)
    self.animation = Animation({
        texture = self.texture,
            frames = {
                love.graphics.newQuad(0, 0, 16, 16, self.texture:getDimensions()),
                love.graphics.newQuad(16, 0, 16, 16, self.texture:getDimensions()),
                love.graphics.newQuad(32, 0, 16, 16, self.texture:getDimensions()),
                love.graphics.newQuad(48, 0, 16, 16, self.texture:getDimensions()),
                love.graphics.newQuad(64, 0, 16, 16, self.texture:getDimensions()),
                love.graphics.newQuad(80, 0, 16, 16, self.texture:getDimensions()),
                love.graphics.newQuad(96, 0, 16, 16, self.texture:getDimensions()),
                love.graphics.newQuad(112, 0, 16, 16, self.texture:getDimensions()),
                love.graphics.newQuad(128, 0, 16, 16, self.texture:getDimensions())
            },
            interval == 1 / 12,
            loop = false
    })
    self.currentFrame = self.animation:getCurrentFrame()
end

function Xplosion:update(dt)
    self.animation:update(dt)
    self.currentFrame = self.animation:getCurrentFrame()
end

function Xplosion:draw()
    love.graphics.draw(self.texture, self.currentFrame, self.entity.x, self.entity.y, 0, self.size, self.size, 8, 8)
end